read("../nearest_singular_poly_functions.mpl");
read("../numeric_poly_linalg.mpl");
#this uses a nearby exactly rank deficient matrix...
RQ_examples := proc(my_file:="experiments")
	local 	n,#dimension
		d, 
		r, #rank deficiency
		e, #exponent
		num_iter,
		DA,
		DA_vars,
		AA,
		C,
		K, 
		bb,
		b_perturb,
		null_init, #error in devectorized kernel vector.
		fd,
		z,#WARNING: Do not make $t$ local... :(
		newton_error,
		Al,Ar,QQ,Ql,Qr,Alp,Arp,A_init,b_init,rel_error, converged
		;
		
	
		r:=1; #Rank deficient by 1
		
		fd:=fclose(my_file); #close it...
		fd:= fopen(my_file,WRITE);
		Digits:=35: #quad precision?
		for n from  3 to 12 by 3 do 
		    for d from 2 to 10 by 2 do
			for e from -12	 to -2 by 2 do
			    
		
		do 
		    AA, Al, Ar := generate_singular_matrix_rank_factored(n, n, n-r, d, t);
		    QQ, Ql, Qr := generate_singular_matrix_rank_factored(n, n, n-r, d, t); 
		    DA, DA_vars := generate_unstructured_perturbation(AA, t);
		    C := evalf(generate_perturbation(AA));
		    C := C/poly_norm_opt(C, t); 
		    C := evalf(C*10^e);
		    Al := Al/poly_norm_opt(Al, t);
		    Ar := Ar/poly_norm_opt(Ar, t); 
		    Alp := Ql;
		    Alp := Alp*10^e/poly_norm_opt(Alp, t);
		    Arp := Qr;
		    Arp := Arp*10^e/poly_norm_opt(Arp, t);
		    A_init := evalf(collect((Al+Alp).(Ar+Arp),t));
		    
		    A_lin := linearize_A(evalf(A_init),t)[1];
		    K:= compute_orthonormal_kernel(A_lin,1e-32);
		    b_init_lin :=  extract_minimally_embedded_kernel_vector(K); #here be a minimally embedded vector!
		    
		    b_init := devectorize(b_init_lin,n,d,t,1e-25);
		    
		    
		    
		    A_init := evalf(A_init/poly_norm_opt(A_init, t));
		    
		    null_init :=  poly_norm_opt(A_init. b_init,t); 
		    
		    AA := evalf(AA/poly_norm_opt(AA, t));
		    b_init := collect(evalf(b_init/poly_norm_opt(b_init, t)), t); 
		    A_init := A_init/poly_norm_opt(A_init,t);
		    
		    print(check_support(AA,A_init,t));
		    
		    if check_support(AA,A_init,t) = true  then break fi: 
		    #this loop is needed to fix some weird cases where the nearby matrix has higher degree.
		od:
		
			   z := constrained_newton(AA+C, DA, DA_vars, A_init, b_init, 15, 0.1e-24,1e2);
			   
			    newton_error := evalf(z[1]/poly_norm_opt(AA+C, t)^2);
			    rel_error := poly_norm_opt(AA+C-A_init, t)^2/poly_norm_opt(A_init, t)^2;
			    num_iter := z[3];
			    converged := z[4];
			    printf("%d & %d & %e & %d & %e & %e\n", n,d,null_init,num_iter,sqrt(rel_error),sqrt(newton_error));
			    fprintf(fd,"%d & %d & %e & %d & %e & %e\n", n,d,null_init,num_iter,sqrt(rel_error),sqrt(newton_error));
			    
			    fflush(fd); 
			   
			od:
		    od:
		od:
		fclose(fd);
end proc:




RQ_examples("RQ_factored_kernel_vector_examples-April-19-2017"); #Run the code